// JavaScript Document

var articleDataStore;         // this will be our datastore
var articleColumnModel;       // this will be our columnmodel
var articleListingEditorGrid;
var articleListingWindow;
var PresidentListingSelectedRow;


Ext.onReady(function(){
  Ext.QuickTips.init();

articleDataStore = new Ext.data.Store({
      id: 'articleDataStore',
      proxy: new Ext.data.HttpProxy({
                url: 'database.php',      // File to connect to
                method: 'POST'
            }),
            baseParams:{task: "LISTING"}, // this parameter asks for listing
      reader: new Ext.data.JsonReader({   
                  // we tell the datastore where to get his data from
        root: 'results',
        totalProperty: 'total',
        id: 'id'
      },[ 
        {name: 'ID', type: 'int', mapping: 'ID'},
		{name: 'lname', type: 'string', mapping: 'lname'},
        {name: 'fname', type: 'string', mapping: 'fname'},
        {name: 'email', type: 'string', mapping: 'email'},
		{name: 'address', type: 'string', mapping: 'address'},
		{name: 'city', type: 'string', mapping: 'city'},
        {name: 'phone', type: 'string', mapping: 'phone'},
        {name: 'phone2', type: 'string', mapping: 'phone2'}
      ]),
      sortInfo:{field: 'ID', direction: "DESC"}
    });

articleColumnModel = new Ext.grid.ColumnModel(
    [{
        header: 'ID',
        readOnly: true,
        dataIndex: 'ID', // this is where the mapped name is important!
        width: 50,
        hidden: false
      },{
		header: 'Last Name',
        dataIndex: 'lname',
        width: 100,
        readOnly: true
		 },{
        header: 'First Name',
        dataIndex: 'fname',
        width: 100,
        readOnly: true
      },{
        header: 'email',
        dataIndex: 'email',
        width: 200,
        readOnly: true
      },{
		
        header: 'Street Address',
        readOnly: true,
        dataIndex: 'address',
        width: 200  
	  },{
        header: 'city',
        dataIndex: 'city',
        width: 50,
        readOnly: true
	  },{
        header: 'Phone Number 1',
        readOnly: true,
        dataIndex: 'phone',
        width: 120                    
      },{
        header: 'Phone Number 2',
        dataIndex: 'phone2',
        width: 120,
        readOnly: true
	  
      }]
    );
    articleColumnModel.defaultSortable= true;
	
	
	
	function confirmDeleteArticle(){
    if(articleListingEditorGrid.selModel.getCount() == 1) // only one president is selected here
    {
      Ext.MessageBox.confirm('Confirmation','Do you Want To Delete This Article Permanently?', deleteArticle);
    } else if(articleListingEditorGrid.selModel.getCount() > 1){
      Ext.MessageBox.confirm('Confirmation','Select Only 1 Please');
    } else {
      Ext.MessageBox.alert('Uh oh...','Nothing Selected');
    }
  }
  
   function deleteArticle(btn){
    if(btn=='yes'){
         var selections = articleListingEditorGrid.selModel.getSelections();
         var prez = [];
         for(i = 0; i< articleListingEditorGrid.selModel.getCount(); i++){
          prez.push(selections[i].json.ID);
         }
         var encoded_array = Ext.encode(prez);
         Ext.Ajax.request({  
            waitMsg: 'Please Wait',
            url: 'database.php', 
            params: { 
               task: "DELETEPRES", 
               ids:  encoded_array
              }, 
            success: function(response){
              var result=eval(response.responseText);
              switch(result){
              case 1:  // Success : simply reload
                articleDataStore.reload();
                break;
              default:
                Ext.MessageBox.alert('Warning','Could not delete the entire selection.');
                break;
              }
            },
            failure: function(response){
              var result=response.responseText;
              Ext.MessageBox.alert('error','could not connect to the database. retry later');      
              }
         });
      }  
  }
  
  function editArticle() {
	  
         var selections = articleListingEditorGrid.selModel.getSelections();
         var prez = [];
         for(i = 0; i< articleListingEditorGrid.selModel.getCount(); i++){
          prez.push(selections[i].json.ID);
         }
         var encoded_array = Ext.encode(prez);
		 var id = encoded_array.replace("[\"", "");
		 var id = id.replace("\"]", "");
		 var address = "editLogin.php?id="+id;
		 window.location = address;
  	}
	
	function newClient() {
         window.location = "createLogin.php";
  	}
	
	
	articleListingEditorGrid =  new Ext.grid.EditorGridPanel({
      id: 'articleListingEditorGrid',
      store: articleDataStore,     // the datastore is defined here
      cm: articleColumnModel,      // the columnmodel is defined here
      enableColLock:false,
      clicksToEdit:1,
      selModel: new Ext.grid.RowSelectionModel({singleSelect:false}),
	  bbar: new Ext.PagingToolbar({
                pageSize: 25,
                store: articleDataStore,
                displayInfo: true
            }),

	  tbar: [
          {
            text: 'Search',
            tooltip: 'Advanced Search',
            handler: startAdvancedSearch,   
            iconCls:'search'
		  }, '-', {
			  text: 'Delete Article',
			  tooltip: 'Delete Selected Article',
			  handler: confirmDeleteArticle,   // Confirm before deleting
			  iconCls:'remove'
		}, '-', {
			  text: 'Edit Client',
			  tooltip: 'Edit Article',
			  handler: editArticle,   // Confirm before deleting
			  iconCls:'add'
    	}, '-', {
			  text: 'New Client',
			  tooltip: 'Create a New Client File',
			  handler: newClient,   // Confirm before deleting
			  iconCls:'add'


      }]
	  
    });
    
  articleListingWindow = new Ext.Window({
      id: 'articleListingWindow',
      title: 'Client Editing Form',
      closable:true,
      width:1000,
      height:500,
      plain:true,
      layout: 'fit',
      items: articleListingEditorGrid  // We'll just put the grid in for now...
    });
  
  articleDataStore.load({params: {start: 0, limit: 25}});      // Load the data
  articleListingWindow.show();   // Display our window
  
});

function startAdvancedSearch(){
      // local vars
      var articleSearchForm;
      var articleSearchWindow;
      var SearchTitle;
 
      
      SearchTitle = new Ext.form.TextField({
          fieldLabel: 'Search Fields',
          maxLength: 30,
          anchor : '95%',
          maskRe: /([a-zA-Z0-9\s]+)$/
            });

articleSearchForm = new Ext.FormPanel({
       labelAlign: 'top',
       bodyStyle: 'padding: 5px',
       width: 300,
       items: [{
         layout: 'form',
         border: false,
         items: [ SearchTitle ],
         buttons: [{
               text: 'Search',
               handler: listSearch
             },{
               text: 'Close',
               handler: resetSearch
             }]
         }]
     });
      
     articleSearchWindow = new Ext.Window({
         title: 'Search',
         closable:true,
         width: 200,
         height: 200,
         plain:true,
         layout: 'fit',
         items: articleSearchForm
     });

	function listSearch(){
                  
         // change the store parameters
    	    articleDataStore.baseParams = {
   			task: 'SEARCH',
   			title: SearchTitle.getValue()
   		};
         // Cause the datastore to do another query : 
   		articleDataStore.reload({params: {start: 0, limit: 25}});
     }
     
     function resetSearch(){
         // reset the store parameters
    		articleDataStore.baseParams = {
   			task: 'LISTING'
   		};
         // Cause the datastore to do another query : 
   		articleDataStore.reload({params: {start: 0, limit: 25}});
         articleSearchWindow.close();
     }
     
     // once all is done, show the search window
     articleSearchWindow.show();
	 
	function onPresidentListingEditorGridContextMenu(grid, rowIndex, e) {
    e.stopEvent();
    var coords = e.getXY();
    PresidentListingContextMenu.rowRecord = grid.store.getAt(rowIndex);
    grid.selModel.selectRow(rowIndex);
    PresidentListingSelectedRow=rowIndex;
    PresidentListingContextMenu.showAt([coords[0], coords[1]]);
  }
}

